import {NgModule} from '@angular/core';
import {RouterModule} from '@angular/router';
import {CommonModule} from '@angular/common';
import {IsCommunity} from '../../connect/communityGuard/isCommunity.guard';
import {ConnectAdminLoginGuard} from '../../connect/communityGuard/connectAdminLoginGuard.guard';
import {NewDivHelpContentComponent} from './new-div-help-content.component';
import {DivHelpContentFormModule} from './div-help-content-form.module';
import {AdminToolServiceModule} from "../../services/adminToolService.module";

@NgModule({
    imports: [
        CommonModule,  RouterModule,
        DivHelpContentFormModule, AdminToolServiceModule
    ],
    declarations: [
        NewDivHelpContentComponent
    ],
    providers: [IsCommunity, ConnectAdminLoginGuard],
    exports: [NewDivHelpContentComponent]
})
export class NewDivHelpContentModule { }
