import {NgModule} from '@angular/core';
import {CommonModule} from '@angular/common';
import {FormsModule, ReactiveFormsModule} from '@angular/forms';
import {RouterModule} from '@angular/router';
import {EntitiesSelectionComponent} from "./entitiesSelection.component";
import {ConfigurationServiceModule} from "../../utils/configuration/configurationService.module";
import {MatSelectModule} from "@angular/material";

@NgModule({
  imports: [
    CommonModule, FormsModule,
    RouterModule, ReactiveFormsModule, ConfigurationServiceModule, MatSelectModule
  ],
  declarations: [
    EntitiesSelectionComponent,
  ],
  providers: [],
  exports: [
    EntitiesSelectionComponent
  ]
})
export class EntitiesSelectionModule {
}
